unit CRC2;
interface
uses strbit32,SysUtils;

function crc(namefile:string):integer;
//  CRC     x^16+x^12+x^5+1
//namefile -   ,      
//   -        ( INTEGER)

function crcsumm(namefile:string):integer;
//  R  
//      32 
//namefile -   ,      
//   -        ( INTEGER)

implementation

function crcsumm(namefile:string):integer;
var
  f:Tbitfile;
//      
  nul,summ:tstr_bit;
//nul-      32 
//summ-    
  rasm:integer;

begin
  f:=tbitfile.create;
  summ:=tstr_bit.Create;
  nul:=tstr_bit.Create;
  f.OpenBitFile(namefile,btOpenRead,bt8);
  f.ChangeOrderBit;//      
  summ.Init_0(32);//  
  nul.Init_0(8); //   
  repeat//      =32
      f.ReadStr(32); //32- 
      rasm:=f.Size;//   
      while f.Size<32 do //  32 
        f.Concat(nul);
      summ.BOOL(f,btxor);// 
  until rasm<32;
  crcsumm:=summ.Nomer(0,32);//     
  f.CloseBitFile;
  f.Free;
  summ.Free;
  nul.Free;
end;


function crc(namefile:string):integer;
var
 ff:tbitfile;
 rasm,ind:longint;
 polinom,sum:tstr_bit;
 flag:boolean;
begin
  ff:=tbitfile.Create;
  polinom:=tstr_bit.Create;
  sum:=tstr_bit.Create;
  ff.OpenBitFile(namefile,btOpenRead,bt8 );
  rasm:=ff.SizeOfFile;
  sum.Init_0(17);
  polinom.Init_Sim('10001000000100001');
  ff.ReadStr(17);
  sum.CopyAllBit(ff);
  if rasm>17 then
   begin

     repeat
       sum.InvStrBit;
       ind:=sum.OpenBit;
       sum.InvStrBit;
       if ind<>0 then
         begin
           ff.ReadStr(ind);
           sum.Concat(ff);
           sum.Delete(0,ind);
         end;
       if sum.Size>=17 then
        begin
         sum.BOOL(polinom,btxor);
         flag:=true;
        end
       else flag:=false;

     until flag=false;
   end;
  //else
 // crc:=ff.Nomer(0,rasm);
  if rasm<>0 then crc:=sum.Nomer(0,sum.Size)
  else crc:=0;
  ff.CloseBitFile;
  polinom.Free;
  sum.Free;
  
end;

end.
